diff --git a/sys/sys/sndstat.h b/sys/sys/sndstat.h
index e0e403b1a72a..6fef6502ec89 100644
--- a/sys/sys/sndstat.h
+++ b/sys/sys/sndstat.h
@@ -68,11 +68,38 @@ struct sndstioc_nv_arg {
 /*
  * sound(4)-specific name/value pair names
  */
-#define SNDST_DSPS_SOUND4_PROVIDER	"sound(4)"
-#define SNDST_DSPS_SOUND4_UNIT		"unit"
-#define SNDST_DSPS_SOUND4_BITPERFECT	"bitperfect"
-#define SNDST_DSPS_SOUND4_PVCHAN	"pvchan"
-#define SNDST_DSPS_SOUND4_RVCHAN	"rvchan"
+#define SNDST_DSPS_SOUND4_PROVIDER		"sound(4)"
+#define SNDST_DSPS_SOUND4_UNIT			"unit"
+#define SNDST_DSPS_SOUND4_BITPERFECT		"bitperfect"
+#define SNDST_DSPS_SOUND4_PVCHAN		"pvchan"
+#define SNDST_DSPS_SOUND4_RVCHAN		"rvchan"
+#define SNDST_DSPS_SOUND4_CHAN_INFO		"channel_info"
+#define SNDST_DSPS_SOUND4_CHAN_NAME		"name"
+#define SNDST_DSPS_SOUND4_CHAN_PARENTCHAN	"parentchan"
+#define SNDST_DSPS_SOUND4_CHAN_UNIT		"unit"
+#define SNDST_DSPS_SOUND4_CHAN_LATENCY		"latency"
+#define SNDST_DSPS_SOUND4_CHAN_RATE		"rate"
+#define SNDST_DSPS_SOUND4_CHAN_FORMAT		"format"
+#define SNDST_DSPS_SOUND4_CHAN_PID		"pid"
+#define SNDST_DSPS_SOUND4_CHAN_COMM		"comm"
+#define SNDST_DSPS_SOUND4_CHAN_INTR		"interrupts"
+#define SNDST_DSPS_SOUND4_CHAN_FEEDCNT		"feedcount"
+#define SNDST_DSPS_SOUND4_CHAN_XRUNS		"xruns"
+#define SNDST_DSPS_SOUND4_CHAN_LEFTVOL		"left_volume"
+#define SNDST_DSPS_SOUND4_CHAN_RIGHTVOL		"right_volume"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_FORMAT	"hwbuf_format"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_SIZE	"hwbuf_size"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_BLKSZ	"hwbuf_blksz"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_BLKCNT	"hwbuf_blkcnt"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_FREE	"hwbuf_free"
+#define SNDST_DSPS_SOUND4_CHAN_HWBUF_READY	"hwbuf_ready"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_FORMAT	"swbuf_format"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_SIZE	"swbuf_size"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_BLKSZ	"swbuf_blksz"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_BLKCNT	"swbuf_blkcnt"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_FREE	"swbuf_free"
+#define SNDST_DSPS_SOUND4_CHAN_SWBUF_READY	"swbuf_ready"
+#define SNDST_DSPS_SOUND4_CHAN_FEEDERCHAIN	"feederchain"
 
 /*
  * Maximum user-specified nvlist buffer size
diff --git a/sys/sys/sysctl.h b/sys/sys/sysctl.h
index bc7a2bc601a1..76cbae25f4e5 100644
--- a/sys/sys/sysctl.h
+++ b/sys/sys/sysctl.h
@@ -395,14 +395,14 @@ TAILQ_HEAD(sysctl_ctx_list, sysctl_ctx_entry);
 #define	SYSCTL_CONST_STRING(parent, nbr, name, access, arg, descr)	\
 	SYSCTL_OID(parent, nbr, name, CTLTYPE_STRING | CTLFLAG_MPSAFE | (access),\
 	    __DECONST(char *, arg), 0, sysctl_handle_string, "A", descr); \
-	CTASSERT(!(access & CTLFLAG_WR));				\
+	CTASSERT(!((access) & CTLFLAG_WR));				\
 	CTASSERT(((access) & CTLTYPE) == 0 ||				\
 	    ((access) & SYSCTL_CT_ASSERT_MASK) == CTLTYPE_STRING)
 
 #define	SYSCTL_ADD_CONST_STRING(ctx, parent, nbr, name, access, arg, descr) \
 ({									\
 	char *__arg = __DECONST(char *, arg);				\
-	CTASSERT(!(access & CTLFLAG_WR));				\
+	CTASSERT(!((access) & CTLFLAG_WR));				\
 	CTASSERT(((access) & CTLTYPE) == 0 ||				\
 	    ((access) & SYSCTL_CT_ASSERT_MASK) == CTLTYPE_STRING);	\
 	sysctl_add_oid(ctx, parent, nbr, name, CTLTYPE_STRING | 	\
diff --git a/sys/sys/timeb.h b/sys/sys/timeb.h
index 952a5e83b8a7..853541e27ae6 100644
--- a/sys/sys/timeb.h
+++ b/sys/sys/timeb.h
@@ -39,7 +39,7 @@
 #ifndef _SYS_TIMEB_H_
 #define _SYS_TIMEB_H_
 
-#ifdef __GNUC__
+#if defined(__GNUC__) && !defined(_IN_LIBUITL)
 #warning "this file includes <sys/timeb.h> which is deprecated"
 #endif
 
diff --git a/sys/vm/vm_init.c b/sys/vm/vm_init.c
index 4ca6e22f8a6d..82efb8236c1d 100644
--- a/sys/vm/vm_init.c
+++ b/sys/vm/vm_init.c
@@ -104,7 +104,7 @@ static void vm_mem_init(void *);
 SYSINIT(vm_mem, SI_SUB_VM, SI_ORDER_FIRST, vm_mem_init, NULL);
 
 /*
- *	vm_init initializes the virtual memory system.
+ *	vm_mem_init() initializes the virtual memory system.
  *	This is done only by the first cpu up.
  */
 static void
diff --git a/sys/x86/include/iommu.h b/sys/x86/include/iommu.h
index a95480b53acc..98c6661aa8e3 100644
--- a/sys/x86/include/iommu.h
+++ b/sys/x86/include/iommu.h
@@ -7,6 +7,7 @@
 
 #include <x86/include/busdma_impl.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 #endif /* !_MACHINE_IOMMU_H_ */
diff --git a/sys/x86/iommu/intel_ctx.c b/sys/x86/iommu/intel_ctx.c
index 65ca88b052ed..444640570df7 100644
--- a/sys/x86/iommu/intel_ctx.c
+++ b/sys/x86/iommu/intel_ctx.c
@@ -66,6 +66,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 static MALLOC_DEFINE(M_DMAR_CTX, "dmar_ctx", "Intel DMAR Context");
@@ -85,7 +86,7 @@ dmar_ensure_ctx_page(struct dmar_unit *dmar, int bus)
 	/*
 	 * Allocated context page must be linked.
 	 */
-	ctxm = dmar_pgalloc(dmar->ctx_obj, 1 + bus, IOMMU_PGF_NOALLOC);
+	ctxm = iommu_pgalloc(dmar->ctx_obj, 1 + bus, IOMMU_PGF_NOALLOC);
 	if (ctxm != NULL)
 		return;
 
@@ -96,14 +97,14 @@ dmar_ensure_ctx_page(struct dmar_unit *dmar, int bus)
 	 * threads are equal.
 	 */
 	TD_PREP_PINNED_ASSERT;
-	ctxm = dmar_pgalloc(dmar->ctx_obj, 1 + bus, IOMMU_PGF_ZERO |
+	ctxm = iommu_pgalloc(dmar->ctx_obj, 1 + bus, IOMMU_PGF_ZERO |
 	    IOMMU_PGF_WAITOK);
-	re = dmar_map_pgtbl(dmar->ctx_obj, 0, IOMMU_PGF_NOALLOC, &sf);
+	re = iommu_map_pgtbl(dmar->ctx_obj, 0, IOMMU_PGF_NOALLOC, &sf);
 	re += bus;
 	dmar_pte_store(&re->r1, DMAR_ROOT_R1_P | (DMAR_ROOT_R1_CTP_MASK &
 	    VM_PAGE_TO_PHYS(ctxm)));
 	dmar_flush_root_to_ram(dmar, re);
-	dmar_unmap_pgtbl(sf);
+	iommu_unmap_pgtbl(sf);
 	TD_PINNED_ASSERT;
 }
 
@@ -115,7 +116,7 @@ dmar_map_ctx_entry(struct dmar_ctx *ctx, struct sf_buf **sfp)
 
 	dmar = CTX2DMAR(ctx);
 
-	ctxp = dmar_map_pgtbl(dmar->ctx_obj, 1 + PCI_RID2BUS(ctx->context.rid),
+	ctxp = iommu_map_pgtbl(dmar->ctx_obj, 1 + PCI_RID2BUS(ctx->context.rid),
 	    IOMMU_PGF_NOALLOC | IOMMU_PGF_WAITOK, sfp);
 	ctxp += ctx->context.rid & 0xff;
 	return (ctxp);
@@ -188,7 +189,7 @@ ctx_id_entry_init(struct dmar_ctx *ctx, dmar_ctx_entry_t *ctxp, bool move,
 		    ("ctx %p non-null pgtbl_obj", ctx));
 		ctx_root = NULL;
 	} else {
-		ctx_root = dmar_pgalloc(domain->pgtbl_obj, 0,
+		ctx_root = iommu_pgalloc(domain->pgtbl_obj, 0,
 		    IOMMU_PGF_NOALLOC);
 	}
 
@@ -274,7 +275,7 @@ domain_init_rmrr(struct dmar_domain *domain, device_t dev, int bus,
 				    "region (%jx, %jx) corrected\n",
 				    domain->iodom.iommu->unit, start, end);
 			}
-			entry->end += DMAR_PAGE_SIZE * 0x20;
+			entry->end += IOMMU_PAGE_SIZE * 0x20;
 		}
 		size = OFF_TO_IDX(entry->end - entry->start);
 		ma = malloc(sizeof(vm_page_t) * size, M_TEMP, M_WAITOK);
@@ -603,9 +604,9 @@ dmar_get_ctx_for_dev1(struct dmar_unit *dmar, device_t dev, uint16_t rid,
 				    func, rid, domain->domain, domain->mgaw,
 				    domain->agaw, id_mapped ? "id" : "re");
 			}
-			dmar_unmap_pgtbl(sf);
+			iommu_unmap_pgtbl(sf);
 		} else {
-			dmar_unmap_pgtbl(sf);
+			iommu_unmap_pgtbl(sf);
 			dmar_domain_destroy(domain1);
 			/* Nothing needs to be done to destroy ctx1. */
 			free(ctx1, M_DMAR_CTX);
@@ -705,7 +706,7 @@ dmar_move_ctx_to_domain(struct dmar_domain *domain, struct dmar_ctx *ctx)
 	ctx->context.domain = &domain->iodom;
 	dmar_ctx_link(ctx);
 	ctx_id_entry_init(ctx, ctxp, true, PCI_BUSMAX + 100);
-	dmar_unmap_pgtbl(sf);
+	iommu_unmap_pgtbl(sf);
 	error = dmar_flush_for_ctx_entry(dmar, true);
 	/* If flush failed, rolling back would not work as well. */
 	printf("dmar%d rid %x domain %d->%d %s-mapped\n",
@@ -789,7 +790,7 @@ dmar_free_ctx_locked(struct dmar_unit *dmar, struct dmar_ctx *ctx)
 	if (ctx->refs > 1) {
 		ctx->refs--;
 		DMAR_UNLOCK(dmar);
-		dmar_unmap_pgtbl(sf);
+		iommu_unmap_pgtbl(sf);
 		TD_PINNED_ASSERT;
 		return;
 	}
@@ -811,7 +812,7 @@ dmar_free_ctx_locked(struct dmar_unit *dmar, struct dmar_ctx *ctx)
 		else
 			dmar_inv_iotlb_glob(dmar);
 	}
-	dmar_unmap_pgtbl(sf);
+	iommu_unmap_pgtbl(sf);
 	domain = CTX2DOM(ctx);
 	dmar_ctx_unlink(ctx);
 	free(ctx->context.tag, M_DMAR_CTX);
diff --git a/sys/x86/iommu/intel_dmar.h b/sys/x86/iommu/intel_dmar.h
index e20144094c80..b7f0300e16f0 100644
--- a/sys/x86/iommu/intel_dmar.h
+++ b/sys/x86/iommu/intel_dmar.h
@@ -123,7 +123,6 @@ struct dmar_msi_data {
 
 struct dmar_unit {
 	struct iommu_unit iommu;
-	device_t dev;
 	uint16_t segment;
 	uint64_t base;
 
@@ -238,16 +237,11 @@ iommu_gaddr_t pglvl_page_size(int total_pglvl, int lvl);
 iommu_gaddr_t domain_page_size(struct dmar_domain *domain, int lvl);
 int calc_am(struct dmar_unit *unit, iommu_gaddr_t base, iommu_gaddr_t size,
     iommu_gaddr_t *isizep);
-struct vm_page *dmar_pgalloc(vm_object_t obj, vm_pindex_t idx, int flags);
-void dmar_pgfree(vm_object_t obj, vm_pindex_t idx, int flags);
-void *dmar_map_pgtbl(vm_object_t obj, vm_pindex_t idx, int flags,
-    struct sf_buf **sf);
-void dmar_unmap_pgtbl(struct sf_buf *sf);
 int dmar_load_root_entry_ptr(struct dmar_unit *unit);
 int dmar_inv_ctx_glob(struct dmar_unit *unit);
 int dmar_inv_iotlb_glob(struct dmar_unit *unit);
 int dmar_flush_write_bufs(struct dmar_unit *unit);
-void dmar_flush_pte_to_ram(struct dmar_unit *unit, dmar_pte_t *dst);
+void dmar_flush_pte_to_ram(struct dmar_unit *unit, iommu_pte_t *dst);
 void dmar_flush_ctx_to_ram(struct dmar_unit *unit, dmar_ctx_entry_t *dst);
 void dmar_flush_root_to_ram(struct dmar_unit *unit, dmar_root_entry_t *dst);
 int dmar_disable_protected_regions(struct dmar_unit *unit);
@@ -315,9 +309,7 @@ void dmar_quirks_pre_use(struct iommu_unit *dmar);
 int dmar_init_irt(struct dmar_unit *unit);
 void dmar_fini_irt(struct dmar_unit *unit);
 
-extern iommu_haddr_t dmar_high;
 extern int haw;
-extern int dmar_tbl_pagecnt;
 extern int dmar_batch_coalesce;
 extern int dmar_rmrr_enable;
 
diff --git a/sys/x86/iommu/intel_drv.c b/sys/x86/iommu/intel_drv.c
index 7346162d1502..0b25620114cd 100644
--- a/sys/x86/iommu/intel_drv.c
+++ b/sys/x86/iommu/intel_drv.c
@@ -67,6 +67,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 #ifdef DEV_APIC
@@ -179,9 +180,9 @@ dmar_identify(driver_t *driver, device_t parent)
 		return;
 	haw = dmartbl->Width + 1;
 	if ((1ULL << (haw + 1)) > BUS_SPACE_MAXADDR)
-		dmar_high = BUS_SPACE_MAXADDR;
+		iommu_high = BUS_SPACE_MAXADDR;
 	else
-		dmar_high = 1ULL << (haw + 1);
+		iommu_high = 1ULL << (haw + 1);
 	if (bootverbose) {
 		printf("DMAR HAW=%d flags=<%b>\n", dmartbl->Width,
 		    (unsigned)dmartbl->Flags,
@@ -409,7 +410,6 @@ dmar_attach(device_t dev)
 	int i, error;
 
 	unit = device_get_softc(dev);
-	unit->dev = dev;
 	unit->iommu.unit = device_get_unit(dev);
 	unit->iommu.dev = dev;
 	dmaru = dmar_find_by_index(unit->iommu.unit);
@@ -490,7 +490,7 @@ dmar_attach(device_t dev)
 	 * address translation after the required invalidations are
 	 * done.
 	 */
-	dmar_pgalloc(unit->ctx_obj, 0, IOMMU_PGF_WAITOK | IOMMU_PGF_ZERO);
+	iommu_pgalloc(unit->ctx_obj, 0, IOMMU_PGF_WAITOK | IOMMU_PGF_ZERO);
 	DMAR_LOCK(unit);
 	error = dmar_load_root_entry_ptr(unit);
 	if (error != 0) {
diff --git a/sys/x86/iommu/intel_fault.c b/sys/x86/iommu/intel_fault.c
index e275304c8d51..59b482720cf1 100644
--- a/sys/x86/iommu/intel_fault.c
+++ b/sys/x86/iommu/intel_fault.c
@@ -54,6 +54,7 @@
 #include <x86/include/busdma_impl.h>
 #include <x86/iommu/intel_reg.h>
 #include <dev/iommu/busdma_iommu.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 /*
diff --git a/sys/x86/iommu/intel_idpgtbl.c b/sys/x86/iommu/intel_idpgtbl.c
index 26f067e35278..82cac8bb2d39 100644
--- a/sys/x86/iommu/intel_idpgtbl.c
+++ b/sys/x86/iommu/intel_idpgtbl.c
@@ -64,6 +64,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 static int domain_unmap_buf_locked(struct dmar_domain *domain,
@@ -109,7 +110,7 @@ domain_idmap_nextlvl(struct idpgtbl *tbl, int lvl, vm_pindex_t idx,
     iommu_gaddr_t addr)
 {
 	vm_page_t m1;
-	dmar_pte_t *pte;
+	iommu_pte_t *pte;
 	struct sf_buf *sf;
 	iommu_gaddr_t f, pg_sz;
 	vm_pindex_t base;
@@ -118,28 +119,28 @@ domain_idmap_nextlvl(struct idpgtbl *tbl, int lvl, vm_pindex_t idx,
 	VM_OBJECT_ASSERT_LOCKED(tbl->pgtbl_obj);
 	if (addr >= tbl->maxaddr)
 		return;
-	(void)dmar_pgalloc(tbl->pgtbl_obj, idx, IOMMU_PGF_OBJL |
+	(void)iommu_pgalloc(tbl->pgtbl_obj, idx, IOMMU_PGF_OBJL |
 	    IOMMU_PGF_WAITOK | IOMMU_PGF_ZERO);
-	base = idx * DMAR_NPTEPG + 1; /* Index of the first child page of idx */
+	base = idx * IOMMU_NPTEPG + 1; /* Index of the first child page of idx */
 	pg_sz = pglvl_page_size(tbl->pglvl, lvl);
 	if (lvl != tbl->leaf) {
-		for (i = 0, f = addr; i < DMAR_NPTEPG; i++, f += pg_sz)
+		for (i = 0, f = addr; i < IOMMU_NPTEPG; i++, f += pg_sz)
 			domain_idmap_nextlvl(tbl, lvl + 1, base + i, f);
 	}
 	VM_OBJECT_WUNLOCK(tbl->pgtbl_obj);
-	pte = dmar_map_pgtbl(tbl->pgtbl_obj, idx, IOMMU_PGF_WAITOK, &sf);
+	pte = iommu_map_pgtbl(tbl->pgtbl_obj, idx, IOMMU_PGF_WAITOK, &sf);
 	if (lvl == tbl->leaf) {
-		for (i = 0, f = addr; i < DMAR_NPTEPG; i++, f += pg_sz) {
+		for (i = 0, f = addr; i < IOMMU_NPTEPG; i++, f += pg_sz) {
 			if (f >= tbl->maxaddr)
 				break;
 			pte[i].pte = (DMAR_PTE_ADDR_MASK & f) |
 			    DMAR_PTE_R | DMAR_PTE_W;
 		}
 	} else {
-		for (i = 0, f = addr; i < DMAR_NPTEPG; i++, f += pg_sz) {
+		for (i = 0, f = addr; i < IOMMU_NPTEPG; i++, f += pg_sz) {
 			if (f >= tbl->maxaddr)
 				break;
-			m1 = dmar_pgalloc(tbl->pgtbl_obj, base + i,
+			m1 = iommu_pgalloc(tbl->pgtbl_obj, base + i,
 			    IOMMU_PGF_NOALLOC);
 			KASSERT(m1 != NULL, ("lost page table page"));
 			pte[i].pte = (DMAR_PTE_ADDR_MASK &
@@ -147,7 +148,7 @@ domain_idmap_nextlvl(struct idpgtbl *tbl, int lvl, vm_pindex_t idx,
 		}
 	}
 	/* domain_get_idmap_pgtbl flushes CPU cache if needed. */
-	dmar_unmap_pgtbl(sf);
+	iommu_unmap_pgtbl(sf);
 	VM_OBJECT_WLOCK(tbl->pgtbl_obj);
 }
 
@@ -301,7 +302,7 @@ put_idmap_pgtbl(vm_object_t obj)
 		rmobj = tbl->pgtbl_obj;
 		if (rmobj->ref_count == 1) {
 			LIST_REMOVE(tbl, link);
-			atomic_subtract_int(&dmar_tbl_pagecnt,
+			atomic_subtract_int(&iommu_tbl_pagecnt,
 			    rmobj->resident_page_count);
 			vm_object_deallocate(rmobj);
 			free(tbl, M_DMAR_IDPGTBL);
@@ -323,9 +324,9 @@ static int
 domain_pgtbl_pte_off(struct dmar_domain *domain, iommu_gaddr_t base, int lvl)
 {
 
-	base >>= DMAR_PAGE_SHIFT + (domain->pglvl - lvl - 1) *
-	    DMAR_NPTEPGSHIFT;
-	return (base & DMAR_PTEMASK);
+	base >>= IOMMU_PAGE_SHIFT + (domain->pglvl - lvl - 1) *
+	    IOMMU_NPTEPGSHIFT;
+	return (base & IOMMU_PTEMASK);
 }
 
 /*
@@ -344,18 +345,18 @@ domain_pgtbl_get_pindex(struct dmar_domain *domain, iommu_gaddr_t base, int lvl)
 
 	for (pidx = idx = 0, i = 0; i < lvl; i++, pidx = idx) {
 		idx = domain_pgtbl_pte_off(domain, base, i) +
-		    pidx * DMAR_NPTEPG + 1;
+		    pidx * IOMMU_NPTEPG + 1;
 	}
 	return (idx);
 }
 
-static dmar_pte_t *
+static iommu_pte_t *
 domain_pgtbl_map_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
     int flags, vm_pindex_t *idxp, struct sf_buf **sf)
 {
 	vm_page_t m;
 	struct sf_buf *sfp;
-	dmar_pte_t *pte, *ptep;
+	iommu_pte_t *pte, *ptep;
 	vm_pindex_t idx, idx1;
 
 	DMAR_DOMAIN_ASSERT_PGLOCKED(domain);
@@ -363,13 +364,13 @@ domain_pgtbl_map_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 
 	idx = domain_pgtbl_get_pindex(domain, base, lvl);
 	if (*sf != NULL && idx == *idxp) {
-		pte = (dmar_pte_t *)sf_buf_kva(*sf);
+		pte = (iommu_pte_t *)sf_buf_kva(*sf);
 	} else {
 		if (*sf != NULL)
-			dmar_unmap_pgtbl(*sf);
+			iommu_unmap_pgtbl(*sf);
 		*idxp = idx;
 retry:
-		pte = dmar_map_pgtbl(domain->pgtbl_obj, idx, flags, sf);
+		pte = iommu_map_pgtbl(domain->pgtbl_obj, idx, flags, sf);
 		if (pte == NULL) {
 			KASSERT(lvl > 0,
 			    ("lost root page table page %p", domain));
@@ -378,7 +379,7 @@ domain_pgtbl_map_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 			 * it and create a pte in the preceeding page level
 			 * to reference the allocated page table page.
 			 */
-			m = dmar_pgalloc(domain->pgtbl_obj, idx, flags |
+			m = iommu_pgalloc(domain->pgtbl_obj, idx, flags |
 			    IOMMU_PGF_ZERO);
 			if (m == NULL)
 				return (NULL);
@@ -399,7 +400,7 @@ domain_pgtbl_map_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 				KASSERT(m->pindex != 0,
 				    ("loosing root page %p", domain));
 				m->ref_count--;
-				dmar_pgfree(domain->pgtbl_obj, m->pindex,
+				iommu_pgfree(domain->pgtbl_obj, m->pindex,
 				    flags);
 				return (NULL);
 			}
@@ -408,7 +409,7 @@ domain_pgtbl_map_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 			dmar_flush_pte_to_ram(domain->dmar, ptep);
 			sf_buf_page(sfp)->ref_count += 1;
 			m->ref_count--;
-			dmar_unmap_pgtbl(sfp);
+			iommu_unmap_pgtbl(sfp);
 			/* Only executed once. */
 			goto retry;
 		}
@@ -421,7 +422,7 @@ static int
 domain_map_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
     iommu_gaddr_t size, vm_page_t *ma, uint64_t pflags, int flags)
 {
-	dmar_pte_t *pte;
+	iommu_pte_t *pte;
 	struct sf_buf *sf;
 	iommu_gaddr_t pg_sz, base1;
 	vm_pindex_t pi, c, idx, run_sz;
@@ -438,7 +439,7 @@ domain_map_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
 	    pi += run_sz) {
 		for (lvl = 0, c = 0, superpage = false;; lvl++) {
 			pg_sz = domain_page_size(domain, lvl);
-			run_sz = pg_sz >> DMAR_PAGE_SHIFT;
+			run_sz = pg_sz >> IOMMU_PAGE_SHIFT;
 			if (lvl == domain->pglvl - 1)
 				break;
 			/*
@@ -477,7 +478,7 @@ domain_map_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
 			KASSERT((flags & IOMMU_PGF_WAITOK) == 0,
 			    ("failed waitable pte alloc %p", domain));
 			if (sf != NULL)
-				dmar_unmap_pgtbl(sf);
+				iommu_unmap_pgtbl(sf);
 			domain_unmap_buf_locked(domain, base1, base - base1,
 			    flags);
 			TD_PINNED_ASSERT;
@@ -489,7 +490,7 @@ domain_map_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
 		sf_buf_page(sf)->ref_count += 1;
 	}
 	if (sf != NULL)
-		dmar_unmap_pgtbl(sf);
+		iommu_unmap_pgtbl(sf);
 	TD_PINNED_ASSERT;
 	return (0);
 }
@@ -513,10 +514,10 @@ domain_map_buf(struct iommu_domain *iodom, iommu_gaddr_t base,
 
 	KASSERT((domain->iodom.flags & IOMMU_DOMAIN_IDMAP) == 0,
 	    ("modifying idmap pagetable domain %p", domain));
-	KASSERT((base & DMAR_PAGE_MASK) == 0,
+	KASSERT((base & IOMMU_PAGE_MASK) == 0,
 	    ("non-aligned base %p %jx %jx", domain, (uintmax_t)base,
 	    (uintmax_t)size));
-	KASSERT((size & DMAR_PAGE_MASK) == 0,
+	KASSERT((size & IOMMU_PAGE_MASK) == 0,
 	    ("non-aligned size %p %jx %jx", domain, (uintmax_t)base,
 	    (uintmax_t)size));
 	KASSERT(size > 0, ("zero size %p %jx %jx", domain, (uintmax_t)base,
@@ -563,7 +564,7 @@ domain_map_buf(struct iommu_domain *iodom, iommu_gaddr_t base,
 }
 
 static void domain_unmap_clear_pte(struct dmar_domain *domain,
-    iommu_gaddr_t base, int lvl, int flags, dmar_pte_t *pte,
+    iommu_gaddr_t base, int lvl, int flags, iommu_pte_t *pte,
     struct sf_buf **sf, bool free_fs);
 
 static void
@@ -571,7 +572,7 @@ domain_free_pgtbl_pde(struct dmar_domain *domain, iommu_gaddr_t base,
     int lvl, int flags)
 {
 	struct sf_buf *sf;
-	dmar_pte_t *pde;
+	iommu_pte_t *pde;
 	vm_pindex_t idx;
 
 	sf = NULL;
@@ -581,7 +582,7 @@ domain_free_pgtbl_pde(struct dmar_domain *domain, iommu_gaddr_t base,
 
 static void
 domain_unmap_clear_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
-    int flags, dmar_pte_t *pte, struct sf_buf **sf, bool free_sf)
+    int flags, iommu_pte_t *pte, struct sf_buf **sf, bool free_sf)
 {
 	vm_page_t m;
 
@@ -589,7 +590,7 @@ domain_unmap_clear_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 	dmar_flush_pte_to_ram(domain->dmar, pte);
 	m = sf_buf_page(*sf);
 	if (free_sf) {
-		dmar_unmap_pgtbl(*sf);
+		iommu_unmap_pgtbl(*sf);
 		*sf = NULL;
 	}
 	m->ref_count--;
@@ -601,7 +602,7 @@ domain_unmap_clear_pte(struct dmar_domain *domain, iommu_gaddr_t base, int lvl,
 	KASSERT(m->pindex != 0,
 	    ("lost reference (idx) on root pg domain %p base %jx lvl %d",
 	    domain, (uintmax_t)base, lvl));
-	dmar_pgfree(domain->pgtbl_obj, m->pindex, flags);
+	iommu_pgfree(domain->pgtbl_obj, m->pindex, flags);
 	domain_free_pgtbl_pde(domain, base, lvl - 1, flags);
 }
 
@@ -612,7 +613,7 @@ static int
 domain_unmap_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
     iommu_gaddr_t size, int flags)
 {
-	dmar_pte_t *pte;
+	iommu_pte_t *pte;
 	struct sf_buf *sf;
 	vm_pindex_t idx;
 	iommu_gaddr_t pg_sz;
@@ -624,10 +625,10 @@ domain_unmap_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
 
 	KASSERT((domain->iodom.flags & IOMMU_DOMAIN_IDMAP) == 0,
 	    ("modifying idmap pagetable domain %p", domain));
-	KASSERT((base & DMAR_PAGE_MASK) == 0,
+	KASSERT((base & IOMMU_PAGE_MASK) == 0,
 	    ("non-aligned base %p %jx %jx", domain, (uintmax_t)base,
 	    (uintmax_t)size));
-	KASSERT((size & DMAR_PAGE_MASK) == 0,
+	KASSERT((size & IOMMU_PAGE_MASK) == 0,
 	    ("non-aligned size %p %jx %jx", domain, (uintmax_t)base,
 	    (uintmax_t)size));
 	KASSERT(base < (1ULL << domain->agaw),
@@ -670,7 +671,7 @@ domain_unmap_buf_locked(struct dmar_domain *domain, iommu_gaddr_t base,
 		    (uintmax_t)base, (uintmax_t)size, (uintmax_t)pg_sz));
 	}
 	if (sf != NULL)
-		dmar_unmap_pgtbl(sf);
+		iommu_unmap_pgtbl(sf);
 	/*
 	 * See 11.1 Write Buffer Flushing for an explanation why RWBF
 	 * can be ignored there.
@@ -706,7 +707,7 @@ domain_alloc_pgtbl(struct dmar_domain *domain)
 	domain->pgtbl_obj = vm_pager_allocate(OBJT_PHYS, NULL,
 	    IDX_TO_OFF(pglvl_max_pages(domain->pglvl)), 0, 0, NULL);
 	DMAR_DOMAIN_PGLOCK(domain);
-	m = dmar_pgalloc(domain->pgtbl_obj, 0, IOMMU_PGF_WAITOK |
+	m = iommu_pgalloc(domain->pgtbl_obj, 0, IOMMU_PGF_WAITOK |
 	    IOMMU_PGF_ZERO | IOMMU_PGF_OBJL);
 	/* No implicit free of the top level page table page. */
 	m->ref_count = 1;
diff --git a/sys/x86/iommu/intel_intrmap.c b/sys/x86/iommu/intel_intrmap.c
index b2642197902a..137801125c38 100644
--- a/sys/x86/iommu/intel_intrmap.c
+++ b/sys/x86/iommu/intel_intrmap.c
@@ -55,6 +55,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 #include <x86/iommu/iommu_intrmap.h>
 
@@ -271,7 +272,7 @@ dmar_ir_program_irte(struct dmar_unit *unit, u_int idx, uint64_t low,
 	high = DMAR_IRTE2_SVT_RID | DMAR_IRTE2_SQ_RID |
 	    DMAR_IRTE2_SID_RID(rid);
 	if (bootverbose) {
-		device_printf(unit->dev,
+		device_printf(unit->iommu.dev,
 		    "programming irte[%d] rid %#x high %#jx low %#jx\n",
 		    idx, rid, (uintmax_t)high, (uintmax_t)low);
 	}
@@ -335,13 +336,13 @@ dmar_init_irt(struct dmar_unit *unit)
 	if (!unit->qi_enabled) {
 		unit->ir_enabled = 0;
 		if (bootverbose)
-			device_printf(unit->dev,
+			device_printf(unit->iommu.dev,
 	     "QI disabled, disabling interrupt remapping\n");
 		return (0);
 	}
 	unit->irte_cnt = clp2(num_io_irqs);
 	unit->irt = kmem_alloc_contig(unit->irte_cnt * sizeof(dmar_irte_t),
-	    M_ZERO | M_WAITOK, 0, dmar_high, PAGE_SIZE, 0,
+	    M_ZERO | M_WAITOK, 0, iommu_high, PAGE_SIZE, 0,
 	    DMAR_IS_COHERENT(unit) ?
 	    VM_MEMATTR_DEFAULT : VM_MEMATTR_UNCACHEABLE);
 	if (unit->irt == NULL)
diff --git a/sys/x86/iommu/intel_qi.c b/sys/x86/iommu/intel_qi.c
index 37e2bf211e32..590cbac9bcbd 100644
--- a/sys/x86/iommu/intel_qi.c
+++ b/sys/x86/iommu/intel_qi.c
@@ -55,6 +55,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 static bool
@@ -501,7 +502,7 @@ dmar_init_qi(struct dmar_unit *unit)
 
 	/* The invalidation queue reads by DMARs are always coherent. */
 	unit->inv_queue = kmem_alloc_contig(unit->inv_queue_size, M_WAITOK |
-	    M_ZERO, 0, dmar_high, PAGE_SIZE, 0, VM_MEMATTR_DEFAULT);
+	    M_ZERO, 0, iommu_high, PAGE_SIZE, 0, VM_MEMATTR_DEFAULT);
 	unit->inv_waitd_seq_hw_phys = pmap_kextract(
 	    (vm_offset_t)&unit->inv_waitd_seq_hw);
 
diff --git a/sys/x86/iommu/intel_quirks.c b/sys/x86/iommu/intel_quirks.c
index 589764bd0fa9..b405a24c4c8c 100644
--- a/sys/x86/iommu/intel_quirks.c
+++ b/sys/x86/iommu/intel_quirks.c
@@ -59,6 +59,7 @@
 #include <x86/include/busdma_impl.h>
 #include <dev/iommu/busdma_iommu.h>
 #include <x86/iommu/intel_reg.h>
+#include <x86/iommu/x86_iommu.h>
 #include <x86/iommu/intel_dmar.h>
 
 typedef void (*dmar_quirk_cpu_fun)(struct dmar_unit *);
@@ -108,7 +109,7 @@ dmar_match_quirks(struct dmar_unit *dmar,
 				    (nb_quirk->rev_no == rev_no ||
 				    nb_quirk->rev_no == QUIRK_NB_ALL_REV)) {
 					if (bootverbose) {
-						device_printf(dmar->dev,
+						device_printf(dmar->iommu.dev,
 						    "NB IOMMU quirk %s\n",
 						    nb_quirk->descr);
 					}
@@ -116,7 +117,8 @@ dmar_match_quirks(struct dmar_unit *dmar,
 				}
 			}
 		} else {
-			device_printf(dmar->dev, "cannot find northbridge\n");
+			device_printf(dmar->iommu.dev,
+			    "cannot find northbridge\n");
 		}
 	}
 	if (cpu_quirks != NULL) {
@@ -135,7 +137,7 @@ dmar_match_quirks(struct dmar_unit *dmar,
 			    (cpu_quirk->stepping == -1 ||
 			    cpu_quirk->stepping == stepping)) {
 				if (bootverbose) {
-					device_printf(dmar->dev,
+					device_printf(dmar->iommu.dev,
 					    "CPU IOMMU quirk %s\n",
 					    cpu_quirk->descr);
 				}
diff --git a/sys/x86/iommu/intel_reg.h b/sys/x86/iommu/intel_reg.h
index 26a18ff94890..0fafcce7accf 100644
--- a/sys/x86/iommu/intel_reg.h
+++ b/sys/x86/iommu/intel_reg.h
@@ -31,16 +31,6 @@
 #ifndef __X86_IOMMU_INTEL_REG_H
 #define	__X86_IOMMU_INTEL_REG_H
 
-#define	DMAR_PAGE_SIZE	PAGE_SIZE
-#define	DMAR_PAGE_MASK	(DMAR_PAGE_SIZE - 1)
-#define	DMAR_PAGE_SHIFT	PAGE_SHIFT
-#define	DMAR_NPTEPG	(DMAR_PAGE_SIZE / sizeof(dmar_pte_t))
-#define	DMAR_NPTEPGSHIFT 9
-#define	DMAR_PTEMASK	(DMAR_NPTEPG - 1)
-
-#define	IOMMU_PAGE_SIZE	DMAR_PAGE_SIZE
-#define	IOMMU_PAGE_MASK	DMAR_PAGE_MASK
-
 typedef struct dmar_root_entry {
 	uint64_t r1;
 	uint64_t r2;
@@ -49,7 +39,7 @@ typedef struct dmar_root_entry {
 #define	DMAR_ROOT_R1_CTP_MASK	0xfffffffffffff000 /* Mask for Context-Entry
 						      Table Pointer */
 
-#define	DMAR_CTX_CNT		(DMAR_PAGE_SIZE / sizeof(dmar_root_entry_t))
+#define	DMAR_CTX_CNT		(IOMMU_PAGE_SIZE / sizeof(dmar_root_entry_t))
 
 typedef	struct dmar_ctx_entry {
 	uint64_t ctx1;
@@ -73,9 +63,6 @@ typedef	struct dmar_ctx_entry {
 #define	DMAR_CTX2_DID(x)	((x) << 8)	/* Domain Identifier */
 #define	DMAR_CTX2_GET_DID(ctx2)	(((ctx2) & DMAR_CTX2_DID_MASK) >> 8)
 
-typedef struct dmar_pte {
-	uint64_t pte;
-} dmar_pte_t;
 #define	DMAR_PTE_R		1		/* Read */
 #define	DMAR_PTE_W		(1 << 1)	/* Write */
 #define	DMAR_PTE_SP		(1 << 7)	/* Super Page */
